X-Git-Url: https://git.madduck.net/code/vcsh.git/blobdiff_plain/6046fecd2148d7ab42e9c68bcc8ce04d74fe10cd..a6c9dc49e9e9749b7dd3b659934193ca61eccae9:/vcsh?ds=inline

diff --git a/vcsh b/vcsh
index 0ec2bba..543a75e 100755
--- a/vcsh
+++ b/vcsh
@@ -1,7 +1,7 @@
 #!/bin/sh
 
 # This program is licensed under the GNU GPL version 2 or later.
-# (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
+# (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2015
 # For details, see LICENSE. To submit patches, you have to agree to
 # license your code under the GNU GPL version 2 or later.
 
@@ -19,11 +19,12 @@
 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
 # version of vcsh; the master branch is supposed to be clean at all times
 # so you can most likely just use it nonetheless
-VERSION='1.20140313'
+VERSION='1.20141026'
 SELF=$(basename $0)
 
 fatal() {
 	echo "$SELF: fatal: $1" >&2
+	[ -z $2 ] && exit 1
 	exit $2
 }
 
@@ -75,6 +76,7 @@ fi
 # Read defaults
 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
+: ${VCSH_OVERLAY_D:="$XDG_CONFIG_HOME/vcsh/overlays-enabled"}
 : ${VCSH_BASE:="$HOME"}
 : ${VCSH_GITIGNORE:=exact}
 : ${VCSH_GITATTRIBUTES:=none}
@@ -98,24 +100,30 @@ help() {
    -v                   Enable verbose mode
 
    commands:
-   clone <remote> \\
+   clone [-b <branch>] \\
+         <remote> \\
          [<repo>]       Clone from an existing repository
    commit               Commit in all repositories
    delete <repo>        Delete an existing repository
    enter <repo>         Enter repository; spawn new instance of \$SHELL
+   foreach [<-g>]
+     <git command>      Execute a command for every repository
    help                 Display this help text
    init <repo>          Initialize a new repository
    list                 List all repositories
-   list-tracked         List all files tracked by vcsh
-   list-tracked-by \\
-        <repo>          List files tracked by a repository
+   list-tracked \\
+        [<repo>]        List all files tracked all or one repositories
+   list-untracked \\
+        [<-a>] [<-r>]
+        [<repo>]        List all files not tracked by all or one repositories
    pull                 Pull from all vcsh remotes
    push                 Push to vcsh remotes
    rename <repo> \\
           <newname>     Rename repository
    run <repo> \\
        <command>        Use this repository
-   status [<repo>]      Show statuses of all/one vcsh repositories
+   status \\
+     [--terse] [<repo>] Show statuses of all/one vcsh repositories
    upgrade <repo>       Upgrade repository to currently recommended settings
    version              Print version information
    which <substring>    Find substring in name of any tracked file
@@ -146,23 +154,30 @@ clone() {
 	hook pre-clone
 	init
 	git remote add origin "$GIT_REMOTE"
-	git config branch.master.remote origin
-	git config branch.master.merge  refs/heads/master
-	if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
-		info "remote is empty, not merging anything"
+	git checkout -b "$VCSH_BRANCH" || return $?
+	git config branch."$VCSH_BRANCH".remote origin
+	git config branch."$VCSH_BRANCH".merge  refs/heads/"$VCSH_BRANCH"
+	if [ $(git ls-remote origin "$VCSH_BRANCH" 2> /dev/null | wc -l ) -lt 1 ]; then
+		info "remote is empty, not merging anything.
+  You should add files to your new repository."
 		exit
 	fi
-	git fetch
+	GIT_VERSION_MAJOR=$(git --version | sed -n 's/.* \([0-9]\+\)\..*/\1/p' )
+	if [ 1 -lt "$GIT_VERSION_MAJOR" ];then
+		git fetch origin "$VCSH_BRANCH"
+	else
+		git fetch origin
+	fi
 	hook pre-merge
-	git ls-tree -r --name-only origin/master | (while read object; do
+	git ls-tree -r --name-only origin/"$VCSH_BRANCH" | (while read object; do
 		[ -e "$object" ] &&
 			error "'$object' exists." &&
 			VCSH_CONFLICT=1
 	done
 	[ x"$VCSH_CONFLICT" = x'1' ]) &&
 		fatal "will stop after fetching and not try to merge!
-  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning." 17
-	git merge origin/master
+  Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
+	git -c merge.ff=true merge origin/"$VCSH_BRANCH"
 	hook post-merge
 	hook post-clone
 	retire
@@ -175,7 +190,7 @@ commit() {
 		echo "$VCSH_REPO_NAME: "
 		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 		use
-		git commit --untracked-files=no --quiet
+		git commit --untracked-files=no --quiet $@
 		VCSH_COMMAND_RETURN_CODE=$?
 		echo
 	done
@@ -208,6 +223,27 @@ enter() {
 	hook post-enter
 }
 
+foreach() {
+	hook pre-foreach
+
+	# We default to prefixing `git` to all commands passed to foreach, but
+	# allow running in general context with -g
+	command_prefix=git
+	while getopts "g" flag; do
+		if [ x"$1" = x'-g' ]; then
+			unset command_prefix
+		fi
+		shift 1
+	done
+	for VCSH_REPO_NAME in $(list); do
+		echo "$VCSH_REPO_NAME:"
+		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+		use
+		$command_prefix "$@"
+	done
+	hook post-foreach
+}
+
 git_dir_exists() {
 	[ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
 }
@@ -242,20 +278,80 @@ get_files() {
 }
 
 list_tracked() {
-	for VCSH_REPO_NAME in $(list); do
-		get_files
-	done | sort -u
+	VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
+	if [ -n "$VCSH_REPO_NAME" ]; then
+		get_files | list_tracked_helper
+	else
+		for VCSH_REPO_NAME in $(list); do
+			get_files
+		done | list_tracked_helper
+	fi
+}
+
+list_tracked_helper() {
+	sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | sed 's/[,\&]/\\&/g')," | sort -u
 }
 
 list_tracked_by() {
-	use
-	git ls-files | sort -u
+	list_tracked '' $2
+}
+
+list_untracked() {
+	command -v 'comm' >/dev/null 2>&1 || fatal "Could not find 'comm'"
+
+	temp_file_others=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+	temp_file_untracked=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+	temp_file_untracked_copy=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+
+	# Hack in support for `vcsh list-untracked -r`...
+	exclude_standard_opt='--exclude-standard'
+	directory_opt="--directory"
+	shift 1
+	while getopts "ar" flag; do
+		if [ x"$1" = x'-a' ]; then
+			unset exclude_standard_opt
+		elif [ x"$1" = x'-r' ]; then
+			unset directory_opt
+		fi
+		shift 1
+	done
+	# ...and parse for a potential parameter afterwards. As we shifted things out of $* in during getops, we need to look at $1
+	VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
+
+	if [ -n "$VCSH_REPO_NAME" ]; then
+		list_untracked_helper $VCSH_REPO_NAME
+	else
+		for VCSH_REPO_NAME in $(list); do
+			list_untracked_helper $VCSH_REPO_NAME
+		done
+	fi
+	cat $temp_file_untracked
+
+	unset directory_opt directory_component
+	rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
+}
+
+list_untracked_helper() {
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	git ls-files --others $exclude_standard_opt "$directory_opt" | (
+		while read line; do
+			echo "$line"
+			directory_component=${line%%/*}
+			[ -d "$directory_component" ] && printf '%s/\n' "$directory_component"
+		done
+		) | sort -u > $temp_file_others
+	if [ -z "$ran_once" ]; then
+		ran_once=1
+		cp $temp_file_others $temp_file_untracked || fatal 'Could not copy temp file'
+	fi
+	cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
+	comm -12 $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
 }
 
 pull() {
 	hook pre-pull
 	for VCSH_REPO_NAME in $(list); do
-		printf "$VCSH_REPO_NAME: "
+		printf '%s: ' "$VCSH_REPO_NAME"
 		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 		use
 		git pull
@@ -268,7 +364,7 @@ pull() {
 push() {
 	hook pre-push
 	for VCSH_REPO_NAME in $(list); do
-		printf "$VCSH_REPO_NAME: "
+		printf '%s: ' "$VCSH_REPO_NAME"
 		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 		use
 		git push
@@ -304,29 +400,35 @@ run() {
 }
 
 status() {
+	if [ -t 1 ]; then
+		COLORING="-c color.status=always"
+	fi
 	if [ -n "$VCSH_REPO_NAME" ]; then
-		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
-		use
-		git status --short --untracked-files='no'
-		VCSH_COMMAND_RETURN_CODE=$?
+		status_helper $VCSH_REPO_NAME
 	else
 		for VCSH_REPO_NAME in $(list); do
-			echo "$VCSH_REPO_NAME:"
-			GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
-			use
-			# TODO repos without remote tracking branch error out
-			remote_tracking_branch=$(git rev-parse --abbrev-ref --symbolic-full-name @{u})
-			commits_behind=$(git log ..${remote_tracking_branch} --oneline | wc -l)
-			commits_ahead=$(git log ${remote_tracking_branch}.. --oneline | wc -l)
-			[ ${commits_behind} -ne 0 ] && echo "Behind $remote_tracking_branch by $commits_behind commits"
-			[ ${commits_ahead} -ne 0 ] && echo "Ahead of $remote_tracking_branch by $commits_ahead commits"
-			git status --short --untracked-files='no'
-			VCSH_COMMAND_RETURN_CODE=$?
-			echo
+			STATUS=$(status_helper $VCSH_REPO_NAME "$COLORING")
+			[ -n "$STATUS" -o -z "$VCSH_STATUS_TERSE" ] && echo "$VCSH_REPO_NAME:"
+			[ -n "$STATUS" ]            && echo "$STATUS"
+			[ -z "$VCSH_STATUS_TERSE" ] && echo
 		done
 	fi
 }
 
+status_helper() {
+	GIT_DIR=$VCSH_REPO_D/$1.git; export GIT_DIR
+	VCSH_GIT_OPTIONS=$2
+	use
+	remote_tracking_branch=$(git rev-parse --abbrev-ref --symbolic-full-name @{u} 2> /dev/null) && {
+		commits_behind=$(git log ..${remote_tracking_branch} --oneline | wc -l)
+		commits_ahead=$(git log ${remote_tracking_branch}.. --oneline | wc -l)
+		[ ${commits_behind} -ne 0 ] && echo "Behind $remote_tracking_branch by $commits_behind commits"
+		[ ${commits_ahead} -ne 0 ] && echo "Ahead of $remote_tracking_branch by $commits_ahead commits"
+	}
+	git ${VCSH_GIT_OPTIONS} status --short --untracked-files='no'
+	VCSH_COMMAND_RETURN_CODE=$?
+}
+
 upgrade() {
 	hook pre-upgrade
 	# fake-bare repositories are not bare, actually. Set this to false
@@ -355,11 +457,14 @@ use() {
 }
 
 which() {
-	for VCSH_REPO_NAME in $(list); do
-		for VCSH_FILE in $(get_files); do
-			echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
-		done
-	done | sort -u
+	output=$(for VCSH_REPO_NAME in $(list); do
+		get_files | grep -- "$VCSH_COMMAND_PARAMETER" | sed "s/^/$VCSH_REPO_NAME: /"
+	done | sort -u)
+	if [ -z "$output" ]; then
+		fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
+	else
+		echo "$output"
+	fi
 }
 
 write_gitignore() {
@@ -371,14 +476,21 @@ write_gitignore() {
 
 	use
 	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+	local GIT_VERSION="$(git --version)"
+	local GIT_VERSION_MAJOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\+\)\..*/\1/p')
+	local GIT_VERSION_MINOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\+\)\.\([0-9]\+\)\..*/\2/p')
 	OLDIFS=$IFS
 	IFS=$(printf '\n\t')
 	gitignores=$(for file in $(git ls-files); do
-		while true; do
-			echo "$file"; new=${file%/*}
-			[ x"$file" = x"$new" ] && break
-			file=$new
-		done;
+		if [ $GIT_VERSION_MAJOR -ge 2 -a $GIT_VERSION_MINOR -ge 7 ]; then
+			echo "$file";
+		else
+			while true; do
+				echo "$file"; new=${file%/*}
+				[ x"$file" = x"$new" ] && break
+				file=$new
+			done;
+		fi
 	done | sort -u)
 
 	# Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
@@ -434,11 +546,28 @@ case $VCSH_COMMAND in
 esac    
 
 if [ x"$VCSH_COMMAND" = x'clone' ]; then
+	VCSH_BRANCH=
+	if [ "$2" = -b ]; then
+		VCSH_BRANCH=$3
+		shift
+		shift
+	fi
 	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
 	GIT_REMOTE="$2"
-	[ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
+	[ -n "$VCSH_BRANCH" ] || if [ "$3" = -b ]; then
+		VCSH_BRANCH=$4
+		shift
+		shift
+	fi
+	if [ -n "$3" ]; then
+		VCSH_REPO_NAME=$3
+		[ -z "$VCSH_BRANCH" ] && [ "$4" = -b ] && VCSH_BRANCH=$5
+	else
+		VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
+	fi
 	[ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
 	export VCSH_REPO_NAME
+	[ -n "$VCSH_BRANCH" ] || VCSH_BRANCH=master
 	GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 elif [ "$VCSH_COMMAND" = 'version' ]; then
 	echo "$SELF $VERSION"
@@ -464,13 +593,21 @@ elif [ x"$VCSH_COMMAND" = x'delete' ]           ||
 	[ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
 	                                      GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
 	[ x"$VCSH_COMMAND" = x'run' ]    && shift 2
+elif [ x"$VCSH_COMMAND" = x'foreach' ]; then
+	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a command" 1
+	shift 1
 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
      [ x"$VCSH_COMMAND" = x'list'   ] ||
      [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
+     [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
      [ x"$VCSH_COMMAND" = x'pull'   ] ||
      [ x"$VCSH_COMMAND" = x'push'   ]; then
 	:
 elif [ x"$VCSH_COMMAND" = x'status' ]; then
+	if [ x"$2" = x'--terse' ]; then
+		VCSH_STATUS_TERSE=1; export VCSH_STATUS_TERSE
+		shift
+	fi
 	VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
 elif [ -n "$2" ]; then
 	VCSH_COMMAND='run'; export VCSH_COMMAND
@@ -514,6 +651,17 @@ check_dir "$VCSH_REPO_D"
 
 verbose "$VCSH_COMMAND begin"
 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
+
+# Source repo-specific configuration file
+[ -r "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME" ] && . "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME"
+
+# source overlay functions
+for overlay in "$VCSH_OVERLAY_D/$VCSH_COMMAND"* "$VCSH_OVERLAY_D/$VCSH_REPO_NAME.$VCSH_COMMAND"*; do
+	[ -r "$overlay" ] || continue
+	info "sourcing '$overlay'"
+	. "$overlay"
+done
+
 hook pre-command
 $VCSH_COMMAND "$@"
 hook post-command